﻿# coding :utf-8
# version 4.2 avec NVDA+F4 et NVDA+shift+f4
from NVDAObjects.IAccessible import IAccessible
from tones import beep
from api import  copyToClip
from speech import speak
import characterProcessing
if not hasattr(characterProcessing, "SYMLVL_SOME"):
	SYMLVL_SOME = characterProcessing.SymbolLevel.SOME
else:
	from characterProcessing import SYMLVL_SOME
from ui import message
from .import zRoleTexts
import controlTypes
objList = []

def getIA2Attribute (obj,attribute_value=False,attribute_name ="id"):
	r= hasattr (obj,"IA2Attributes") and attribute_name in obj.IA2Attributes.keys ()
	if not r :return False
	r =obj.IA2Attributes[attribute_name]
	return r if not attribute_value  else r ==attribute_value
	
def ObjectTreeToText(obj, ascendent=0) :
	global objList
	if ascendent > 99 : # role window
		# find window object
		while obj :
			if obj.role == 1 : # window
				break
			obj = obj.parent
	else :
		ascendent += 1 # parent
		i = 0
		while i < ascendent :
			obj = obj.parent
			i += 1
	if not obj :
		message ("Aucun acendant de rang : " + str(ascendent)) 
	nm = "sans nom"
	if obj.name : nm = obj.name
	id = getIA2Attribute(obj) 
	id = ", ID=" + str(id)
	tRol = str(zRoleTexts.roleConsts[int(obj.role)])
	tCount = "ChildCount=" + str(obj.childCount)
	tit = "Arborescence des objets de : %s %s %s %s" % (nm, id, tRol, tCount)
	message ("Récupération de l'" + tit)
	objList = [tit]
	try :
		recurseObjects (obj, int(obj.childCount), 0, "", tRol)
	finally :
		text = "\r\n".join(objList)
		copyToClip (text)
		objList = []
		speak (["La liste des objets est dans le presse-papiers. Voici son ccontenu ", text], symbolLevel=SYMLVL_SOME)
		text = ""


def recurseObjects (oParent, chCount, level, indent, path) :
	global objList
	beep (349, 2)
	if chCount <= 0 : 
		objList.append (ind + "Erreur childCount=" + str(chCount))
		return False
	if  not oParent : 
		objList.append ("Erreur oParent nul")
		return False
	try :
		oChild = oParent.getChild(0)  # firstChild
		if  oChild == None : objList.append ("Erreur firstChild nul")
	except :
		lvl = "niveau %s, " % str(level)
		objList.append (indent + lvl + ", Exception obtention firstChild de : " + path)
		return False
	level += 1
	lvl = "niveau %s, " % str(level)
	ind = "%s " % indent
	maxIdx = chCount - 1
	i = 0
	while oChild :
		cCount  = (int(oChild.childCount) if hasattr(oChild, "childCount") else int(-1))
		#if oChild.role == 31 and i > 20 : return True # role tablerow
		oID = getIA2Attribute(oChild)
		tRole = ""
		if hasattr(oChild, "role") :
			tRole = ", " + zRoleTexts.roleConsts[int(oChild.role)] 
		if not oID :
			tID = tRole
		else :
			tID = tRole + " " + str(oID)
		tFocus = ""
		if hasattr(oChild, "states") :
			tFocus = (", STATE_FOCUSABLe, " if controlTypes.STATE_FOCUSABLE in oChild.states else ", ")
			tFocus = (", STATE_FOCUSED, " if controlTypes.STATE_FOCUSED in oChild.states else tFocus)
		tOrder = "%s sur %s" % (str(i), str(maxIdx))
		tName = ""
		if hasattr(oChild, "name") :
			if not oChild.name :
				tName = ", sans nom"
			else :
				tName = ", nom=" + str(oChild.name[0:30]) # 30 first xchars
		tValue = ""
		if hasattr(oChild, "value") :
			if not oChild.value :
				tValue = ""
			else :
				tValue = ", value=" + str(oChild.value)
		if path == "" : path = "path vide"
		tPath = (u"{0}|{1}".format(path, tID))
		tWndClass = ""  # ", WindowClass=" + str(oChild.windowClassName)
		tLine = ind + lvl + tOrder + ", ID=" + str(oID) + tRole + tFocus  + "childCount=" + str(cCount) + tName + tValue + ", Chemin : " + tPath + tWndClass + " ;"
		objList.append(tLine)
		if cCount > 0 :
			recurseObjects (oChild, cCount, level, ind, tPath)
		i += 1
		try :
			oChild = oChild.next
		except :
			objList.append (ind + tOrder + ", Exception next de : " + tLine)
			objList.append ("Tentative avec getChild " + str(i))
			# 2d attempt
			if i < maxIdx :
				oChild = oParent.getChild(i)
			pass
	return True
def secureGetAttr (obj, attrName, label, default=False) :
	r= hasattr (obj,"IA2Attributes") and attrName in obj.IA2Attributes.keys ()
	if not r :return default
	r =obj.IA2Attributes[attrName]
	if label : r = label + str(r)
	return r


def spychooseNVDAObjectOverlayClasses (obj, curFrame, role, name, objID, clsList) :
	objTag =getIA2Attribute (obj,False,"tag")
	roleText = zRoleTexts.roleConsts[role] # bug avec role=115
	sFocused = ""
	if obj.hasFocus and role > 1 : # la fenêtre a toujours le focus
		sFocused = u"Focalisé"
	# firstChild
	firstChildRole = str(obj.firstChild.role) + zRoleTexts.roleConsts[obj.firstChild.role]
	firstChildID = getIA2Attribute (obj.firstChild)

		# parent
	parentRole = parentID = parentTag = "NA"
	parentRole = str(obj.parent.role) + zRoleTexts.roleConsts[obj.parent.role]
	parentID = getIA2Attribute (obj.parent)
	try :
		parentTag = getIA2Attribute (obj.parent,False,"tag")
	except :
		pass
	containerRole = str(obj.container.role) + zRoleTexts.roleConsts[obj.container.role]
	containerID = getIA2Attribute (obj.container)
	try :
		containerTag = getIA2Attribute (obj.container,False,"tag")
	except :
		pass

	# "\n".join(clsList) ne fonctionne pas 
	cl = str()
	i = 0
	for el in clsList :
		cl += str(i) + ": " + str(el) + "\n"
		i += 1
	lVars = ["Spy chooseClasses", "obj.name=" + str(name),
	"objID= " + str(objID),
	"CurrentFrame= " + str(curFrame),
	"obj role= " + str(role) + roleText,
	"objTag= " + str(objTag),
	sFocused,
	"firstChildRole=" + str(firstChildRole),
	"firstChildID= " + str(firstChildID),
	"parentRole=" + str(parentRole),
	"parentID= " + str(parentID),
	"parentTag= " + str(parentTag),
	"ParentName= " + str(obj.parent.name),
	"containerRole=" + str(containerRole),
	"containerID= " + str(containerID),
	"containerTag= " + str(containerTag),
	"containerName= " + str(obj.container.name),
	"clsList =",
	cl]
	print ("\n".join(lVars))
